SystemOrganization addCategory: #'Seaside-Tests-Tools-Web'!

WAContextTest subclass: #WADispatcherComponentTest
	instanceVariableNames: 'configApplication rootHandler childHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Tools-Web'!

!WADispatcherComponentTest methodsFor: 'private' stamp: 'pmm 9/5/2009 18:23'!
createHandlers
	^Array
		with: rootHandler
		with: configApplication
		with: WASession new! !

!WADispatcherComponentTest methodsFor: 'running' stamp: 'pmm 9/5/2009 16:23'!
setUp
	| normalApplication |
	super setUp.
	rootHandler := WADispatcher new.
	rootHandler := rootHandler register: WADispatcher new at: 'seaside'.
	childHandler := rootHandler register: WADispatcher new at: 'child'.
	configApplication := WAAdmin register: WAApplication 
		at: 'config'
		in: rootHandler.
	configApplication configuration addParent: WARenderLoopConfiguration instance.
	configApplication 
		preferenceAt: #rootClass
		put: WAConfigurationBrowser.
	normalApplication := WAApplication 
		register: 'counter'
		in: childHandler.
	normalApplication configuration addParent: WARenderLoopConfiguration instance.
	normalApplication 
		preferenceAt: #rootClass
		put: WAConfigurationBrowser! !

!WADispatcherComponentTest methodsFor: 'testing' stamp: 'pmm 9/6/2009 12:14'!
testNestedDispatcher
	| configComponent |
	configComponent := WAConfigurationBrowser on: rootHandler.
	self requestContextWithUrl: '/config/child'.
	self requestContext consumer next.
	self requestContext session properties at: #presenter put: WAComponent new.
	configComponent initialRequest: self requestContext request.
	self assert: configComponent dispatcher == childHandler! !

!WAPackage class methodsFor: '*seaside-tests-tools-web' stamp: 'jf 3/14/2009 11:13'!
seasideTestsToolsWeb
	^ self new
		name: 'Seaside-Tests-Tools-Web';
		description: 'Unit tests for the package Seaside-Tools-Web';
		addDependency: 'Seaside-Tools-Web';
		addDependency: 'Seaside-Tests-Environment';
		yourself! !

WAEnvironmentDefaultHandlersTest subclass: #WAToolsWebDefaultHandlersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Tools-Web'!

!WAToolsWebDefaultHandlersTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 14:42'!
testDefaultConfig
	| app |
	app := self defaultDispatcher entryPointAt: 'config'.
	self assert: app class == WAApplication.
	self assert: app isApplication.
	self deny: app isDispatcher.
	self deny: app parent isNil.
	self assert: app name = 'config'.
	self assert: app basePath = '/config'! !

TestCase subclass: #WACloneHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Tools-Web'!

!WACloneHandlerTest methodsFor: 'testing' stamp: 'pmm 9/4/2009 16:01'!
testCloneApplication
	| app handler key clone |
	app := WADispatcher new register: WAApplication new at: 'app'.
	handler := WARequestHandler new.
	key := app register: handler.
	
	clone := app cloneHandler.
	
	self assert: key = (app keyFor: handler).
	self should: [ clone keyFor: handler ] raise: Error.! !
